reducers-3.12.1: Semigroups, specialized containers and a general map/reduce framework

Copyright | (c) Edward Kmett 2009-2011
License | BSD-style
Maintainer | ekmett@gmail.com
Stability | experimental
Portability | non-portable (MPTCs)
Safe Haskell | Trustworthy
Language | Haskell98

Data.Semigroup.Apply

Description

Semigroups for working with `Apply`

Synopsis

- newtype Trav f = Trav {
  - getTrav :: f ()
  }
- newtype App f m = App {
  - getApp :: f m
  }

# Documentation

newtype Trav f #

A `Trav` uses an glues together `Applicative` actions with (*>) in the manner of `traverse_` from Data.Foldable. Any values returned by reduced actions are discarded.

Constructors

Trav |
Fields getTrav :: f ()

Instances

Apply f => Semigroup (Trav f) # |
Methods (<>) :: Trav f -> Trav f -> Trav f # sconcat :: NonEmpty (Trav f) -> Trav f # stimes :: Integral b => b -> Trav f -> Trav f #
Apply f => Reducer (f a) (Trav f) # |
Methods unit :: f a -> Trav f # snoc :: Trav f -> f a -> Trav f # cons :: f a -> Trav f -> Trav f #

newtype App f m #

A `App` turns any `Apply` wrapped around a `Semigroup` into a `Semigroup`

Constructors

App |
Fields getApp :: f m

Instances

Functor f => Functor (App f) # |
Methods fmap :: (a -> b) -> App f a -> App f b # (<$) :: a -> App f b -> App f a #
Apply f => Apply (App f) # |
Methods (<.>) :: App f (a -> b) -> App f a -> App f b # (.>) :: App f a -> App f b -> App f b # (<.) :: App f a -> App f b -> App f a #
(Apply f, Reducer c m) => Reducer (f c) (App f m) # |
Methods unit :: f c -> App f m # snoc :: App f m -> f c -> App f m # cons :: f c -> App f m -> App f m #
(Apply f, Semigroup m) => Semigroup (App f m) # |
Methods (<>) :: App f m -> App f m -> App f m # sconcat :: NonEmpty (App f m) -> App f m # stimes :: Integral b => b -> App f m -> App f m #